# TODO
# - cmake is borken and adds objects (static libs) in the middle of lists (Renderer/libRenderer.a):
#   Linking CXX shared library libprojectM.so
#   /usr/bin/cmake -E cmake_link_script CMakeFiles/projectM-shared.dir/link.txt --verbose=1
#   /usr/bin/ccache  i686-pld-linux-g++ -fPIC -O2 -fno-strict-aliasing -fwrapv -march=i686 -mtune=pentium4 -gdwarf-3 -g2   -fopenmp  -Wl,--as-needed -Wl,--no-copy-dt-needed-entries -Wl,-z,relro -Wl,-z,combreloc  -shared -Wl,-soname,libprojectM.so.2 -o libprojectM.so.2.0.1 CMakeFiles/projectM-shared.dir/projectM.cpp.o CMakeFiles/projectM-shared.dir/PCM.cpp.o CMakeFiles/projectM-shared.dir/Preset.cpp.o CMakeFiles/projectM-shared.dir/fftsg.cpp.o CMakeFiles/projectM-shared.dir/KeyHandler.cpp.o CMakeFiles/projectM-shared.dir/timer.cpp.o CMakeFiles/projectM-shared.dir/wipemalloc.cpp.o CMakeFiles/projectM-shared.dir/PresetLoader.cpp.o CMakeFiles/projectM-shared.dir/PresetChooser.cpp.o CMakeFiles/projectM-shared.dir/PipelineMerger.cpp.o CMakeFiles/projectM-shared.dir/ConfigFile.cpp.o CMakeFiles/projectM-shared.dir/TimeKeeper.cpp.o CMakeFiles/projectM-shared.dir/PresetFactory.cpp.o CMakeFiles/projectM-shared.dir/PresetFactoryManager.cpp.o Renderer/libRenderer.a NativePresetFactory/libNativePresetFactory.a MilkdropPresetFactory/libMilkdropPresetFactory.a -lGLEW -lftgl -lfreetype -lGLU -lGL -lSM -lICE -lX11 -lXext Renderer/libRenderer.a -lm
#
#   CMakeLists.txt having:
#   TARGET_LINK_LIBRARIES(projectM-shared ${PRESET_FACTORY_LINK_TARGETS} ${GLEW_LINK_TARGETS} m dl ${FTGL_LINK_TARGETS} ${OPENGL_LIBRARIES}  ${IMAGE_LINK_TARGETS} ${CG_LINK_TARGETS})
#
#   NativePresetFactory/CMakeLists.txt has:
#   TARGET_LINK_LIBRARIES(NativePresetFactory Renderer m)
#   which mixes .a between -l for dl

%define		pkgname	projectM
Summary:	Awesome music visualizer
Summary(pl.UTF-8):	Imponujący wizualizator muzyki
Name:		libprojectM
Version:	2.0.1
Release:	10
Epoch:		1
License:	LGPL v2.1+
Group:		Libraries
Source0:	http://downloads.sourceforge.net/project/projectm/%{version}/projectM-%{version}-Source.tar.gz
# Source0-md5:	f8bf795878cdbbef54784cf2390b4c89
Patch0:		%{name}-soname.patch
Patch1:		%{name}-fonts.patch
Patch2:		%{name}-static.patch
Patch3:		as-needed.patch
Patch4:		%{name}-pkgconfig.patch
Patch5:		01-change-texture-size.patch
Patch6:		04-change-preset-duration.patch
Patch7:		06-fix-numeric-locale.patch
Patch8:		freetype.patch
URL:		http://projectm.sourceforge.net/
BuildRequires:	OpenGL-devel
BuildRequires:	cmake >= 2.6.0
BuildRequires:	freetype-devel >= 2.0
BuildRequires:	ftgl-devel >= 2.1.3
BuildRequires:	gcc-c++ >= 6:4.2
BuildRequires:	glew-devel
BuildRequires:	libgomp-devel
BuildRequires:	libstdc++-devel
BuildRequires:	pkgconfig
BuildRequires:	rpmbuild(macros) >= 1.577
BuildRequires:	sed >= 4.0
Requires:	fonts-TTF-bitstream-vera
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# cmake (or cmake rules) are broken, mixes .a (objects) with libs (-l)
%define		filterout_ld	-Wl,--as-needed

%description
projectM is a reimplementation of Milkdrop under OpenGL. It is an
awesome music visualizer. There is nothing better in the world of
Unix.

%description -l pl.UTF-8
projectM jest reimplementacją projektu Milkdrop na OpenGL. Jest
imponującym wizualizatorem muzyki. Nie ma nic lepszego w świecie
uniksa.

%package devel
Summary:	Header files for projectM library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki projectM
Group:		Development/Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description devel
Header files for projectM library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki projectM.

%package static
Summary:	Static projectM library
Summary(pl.UTF-8):	Statyczna biblioteka projectM
Group:		Development/Libraries
Requires:	%{name}-devel = %{epoch}:%{version}-%{release}

%description static
Static projectM library.

%description static -l pl.UTF-8
Statyczna biblioteka projectM.

%prep
%setup -q -n projectM-%{version}-Source
%undos config.inp.in
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4	-p1
%patch5	-p0
%patch6	-p0
%patch7	-p0
%patch8 -p1

%build
install -d build
cd build
%cmake \
	-DCMAKE_LIB_DIR=%{_libdir} \
	-DBUILD_PROJECTM_STATIC=yes \
	../
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
# COPYING is just license information, not actual LGPL text
%doc COPYING ChangeLog
%attr(755,root,root) %{_libdir}/libprojectM.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libprojectM.so.2
%dir %{_datadir}/%{pkgname}
%{_datadir}/%{pkgname}/config.inp
%dir %{_datadir}/%{pkgname}/presets
%{_datadir}/%{pkgname}/presets/*.milk
%{_datadir}/%{pkgname}/presets/*.prjm
%{_datadir}/%{pkgname}/presets/*.tga
%dir %{_datadir}/%{pkgname}/shaders
%{_datadir}/%{pkgname}/shaders/*.cg

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libprojectM.so
%{_includedir}/%{name}
%{_pkgconfigdir}/libprojectM.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libprojectM.a
%changelog
* Thu Dec 24 2015 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/libprojectM.git;a=log;h=master

* Thu Dec 24 2015 Jan Rękorajski <baggins@pld-linux.org> 033a712
- release 10 (by relup.sh)

* Sun Jul 12 2015 Jan Rękorajski <baggins@pld-linux.org> 8380d3f
- release 9 (by relup.sh)

* Fri Mar 13 2015 Jan Rękorajski <baggins@pld-linux.org> 59d2a61
- release 8 (by relup.sh)

* Tue Jan 21 2014 Jan Rękorajski <baggins@pld-linux.org> 1c758b2
- fix freetype detection
- rel 7

* Sun Dec 18 2011 Jakub Bogusz <qboosh@pld-linux.org> 7b020ff
- more BRs
- include COPYING in doc (copyright and license notes, not actual LGPL text)
- adjusted as-needed patch (but no success, cmake fault)

* Thu Nov 17 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> e818073
- release 6

* Wed Aug 31 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 45eabbd
- release 5

* Mon Sep 06 2010 Elan Ruusamäe <glen@pld-linux.org> a7d135e
- add patches from clementine 0.5; rel 4

* Thu Jul 08 2010 lisu <lisu@pld-linux.org> 380f104
- force pkgconfig to use -L/usr/lib or -L/usr/lib64 (avoid situations when pkg-config --libs libprojectM returns "-L-libprojectM")

* Thu Jul 08 2010 lisu <lisu@pld-linux.org> 10672d0
- force pkgconfig to use -L/usr/lib or -L/usr/lib64 (avoid situations when pkg-config --libs libprojectM returns "-L-libprojectM")
- rel 3

* Wed Jul 07 2010 Elan Ruusamäe <glen@pld-linux.org> f5c4e73
- cmake as needed broken, disable; rel 2

* Wed Jul 07 2010 Elan Ruusamäe <glen@pld-linux.org> 7b12719
- up to 2.0.1

* Sat Feb 27 2010 sparky <sparky@pld-linux.org> 57351de
- unify %attr() %ghost order

* Tue Sep 22 2009 Adam Gołębiowski <adamg@pld-linux.org> 2edd33b
- new; missing include

* Tue Sep 22 2009 Adam Gołębiowski <adamg@pld-linux.org> a37d40a
- updated to 1.2.0

* Tue Sep 22 2009 Adam Gołębiowski <adamg@pld-linux.org> ba2ba67
- new; fix ftgl include

* Wed Aug 27 2008 Elan Ruusamäe <glen@pld-linux.org> 4379adb
- release 3 (libGLEW soname)

* Tue Aug 05 2008 hawk <hawk@pld-linux.org> 8f8b23a
- release 2

* Tue Apr 01 2008 arvenil <arvenil@pld-linux.org> 93c1478
- added epoch to R: in subpackages

* Mon Mar 31 2008 arvenil <arvenil@pld-linux.org> 470af84
- Epoch: 1 (1.1 == 1.01)

